Below is the current roadmap for the YAML form module.

★ Indicates areas that I need help with. 

Phase I (before Release Candidate)
----------------------------------

### Forms & Elements 

#### Finalize elements

- \#pattern support with regex validation **DONE** 
    - [#2765797]
- Autocompletion element & property support **DONE**
- Select2 support.  **DONE**
    - [#2758671]
- Entity query / Views entity reference support for #options 
    - [#2346973] 

#### User Interface

- Build #options UI. 
    - [#2759527]
- Build #states (conditional logic) UI. 
    - [#2764503]

### Design & UX 

#### Templating ★

- Review and finalize templates 
    - [#2757991]
- Support for multi column responsive layouts. (ie 2 column form)

#### Examples & Templates

- Add better documentation to yamlform_examples.module
- Review out-of-the-box templates provide by the yamlform_templates.module.

### Code & APIs 

#### Code Review

- Testability
- Refactorability
- Plugin definitions ★
- Entity API implementation ★
- Form API implementation ★

#### Security Review ★

- Callback injection
- JS/CSS injection
- Access controls

#### API Review

- Review doc blocks

#### Libraries

- Finalize external library support 
    - [#2745325]
- Add external libraries to composer.json ★

#### Testing

- Refactor PHPUnit tests
- Improve SimpleTest setUp performance.
- Configuration Management
- Default configuration
- Finalize default admin settings

###  Multilingual 

- Finalize how YAML form's elements are translated. ★
- Make sure the YAML form module is completely translatable. ★

### Documentation & Help 

#### General 

- Decide if any documentation should live on Drupal.org
- What is YAML and why we are using it? 
    - [#2759591]
- Move features into a dedicated file.
- Create a related project page
- Simplify the project page.
- Update screenshots

#### Module

- Review hook_help()
- Review hardcoded messages.

#### Editorial ★

- Unified tone
- General typos, grammar, and wording. ★

###  Other 

#### Screencasts

- Form Builder - How to build forms?
- Form Developer - How to customize forms?
- Contributor - How to extend the YAML form API and plugins?

#### Maintainers/Developer

- Document issue queue policies.
- Build full documented plugin examples.


Phase II (after Stable Release)
-------------------------------

### Forms 

- AJAX support for forms ★ 
    - [#2757491]

### Views 

- Views integration ★

### Reporting 

- Customizable reports
- Sortable reports ★ 
    - [#2722601]

### APIs 

- REST API endpoint for CRUD operations.
- Headless Drupal Forms

### Other 

- Code snippets repository
- Template repository


What Webform & EntityForm features are currently missing?
---------------------------------------------------------

### Form settings 

- Limit submission by IP and/or cookie.
- Resetting sid per form.

### Results 

- Analysis of submitted data
- Submission sorting

### Download 

- Excel support
- Last download

### Settings 

- Provide Anonymous Links


Notes
-----

- Analytics and reporting will never be included in the main YAML form module. This should be handled by a dedicated module or third party service.


